/*
 * PM - 2017
 * lab0.c
 */

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		50

#define NUM_NOTE		8

#include "spi.h"
#include "ST7735R_TFT.h"
#include "DS3231.h"
#include "xstepper.h"

char buf[80];
char buf1[80];
static const char *spaces = "                                                                          ";

volatile uint8_t ora_alarma;
volatile uint8_t min_alarma;


int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523
};

volatile int alarm_set = 0;
volatile int var = 0;
int set_ora = 0;
int set_min = 0;
int ora = 0;
int min = 0;

ISR(PCINT3_vect)
{


	if ((PIND & (1 << PD0)) == 0)
    {
		if ((PORTC & (1 << PC4)) == 0){
			PORTC |= (1 << PC4);			
		}else{
			PORTC &= ~(1 << PC4);
		}
		_delay_ms(250);
		
		if (alarm_set == 0) {
			var = 1;
		}else{
			var = 2;
		}
		
		
		
	}

	else if ((PIND & (1 << PD1)) == 0)
    {
		if ((PORTC & (1 << PC4)) == 0){
			PORTC |= (1 << PC4);			
		}else{
			PORTC &= ~(1 << PC4);
		}
		
				
		ora_alarma++;
		if(ora_alarma == 24){
			ora_alarma = 0;
		}
		
		sprintf(buf, "%d:%d", ora_alarma, min_alarma);
		ST7735R_DrawText(50, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(50, 100, buf, 0, 255, 255, 0, 0, 0);
		_delay_ms(250);
	} 
	
	 
	
	
	else if ((PIND & (1 << PD3)) == 0)
    {
		if ((PORTC & (1 << PC4)) == 0){
			PORTC |= (1 << PC4);			
		}else{
			PORTC &= ~(1 << PC4);
		}
		
		
		min_alarma++;
		if(min_alarma == 60){
			min_alarma = 0;
		}
		
		sprintf(buf, "%d:%d", ora_alarma, min_alarma);
		ST7735R_DrawText(50, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(50, 100, buf, 0, 255, 255, 0, 0, 0);
		_delay_ms(250);
				
	} 
	
	
}






/* Genereaza sunetul pentru tipul de ton folosit: lung (150ms) sau scurt (50ms). */
void speaker_morse(int tip_morse) {
	int i;

	/* Alternam starea pinului PD4 la fiecare milisecunda. */
	for (i = 0; i < tip_morse; ++i) {
		PINA = (1 << PA6);
		StepperStepCW();
		_delay_loop_2(10000);
	}
}




void IO_init(){
	
	//pun pe portul a 5 butoane
	DDRD &= ~(1 << PD0) & ~(1 << PD1) & ~(1 << PD2) & ~(1 << PD3) & ~(1 << PD4);
	//activez rezistenta de pull-up
	PORTD |= (1 << PD0) | (1 << PD1) | (1 << PD2) | (1 << PD3) | (1 << PD4);
	
	DDRA |= (1 << PA6);
	PORTA &= ~(1 << PA6);
	
	//setez intrerupere pe PA0 - PA4
	PCICR = 0;
	PCICR |= (1 << PCIE3);
	PCMSK3 = 0;
	PCMSK3 |= (1 << PCINT24) | (1 << PCINT25) | (1 << PCINT26) | (1 << PCINT27) | (1 << PCINT28);
	
}

void setare_alarma(){
	
	TCNT1 = 0;
	OCR1A = 0;
	var = 0;
	uint8_t sec, min, h, m, d, y, s;
	
	ora_alarma = 0;
	min_alarma = 0;
	sprintf(buf1, "SETATI ALARMA");
	ST7735R_DrawText(50, 50, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(20, 50, buf1, 0, 255, 255, 0, 0, 0);
	
	sprintf(buf, "%d:%d", ora_alarma, min_alarma);
	ST7735R_DrawText(50, 100, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(50, 100, buf, 0, 255, 255, 0, 0, 0);
	ora_alarma = 0;
	
	while(var == 0){
			DS3231_getTime(&sec, &min, &h, &s, &d, &m, &y);
			
			
			sprintf(buf, "ORA: %d:%d:%d", h,min,sec);
			//
			ST7735R_DrawText(0, 130, spaces, 255, 255, 0, 0, 0, 0);
			ST7735R_DrawText(0, 130, buf, 0, 255, 255, 0, 0, 0);
			_delay_ms(100);
	}
	var = 0;
	
	sprintf(buf1, "ALARMA SETATA");
	ST7735R_DrawText(50, 50, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(20, 50, buf1, 0, 255, 255, 0, 0, 0);
	
	sprintf(buf, "Ati setat %d:%d", ora_alarma, min_alarma);
	ST7735R_DrawText(50, 100, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
	alarm_set = 1;
	
}

void suna_alarma(){
	uint8_t sec, min, h, m, d, y, s;
	alarm_set = 1;
	while (var != 2) {
		
	
		sprintf(buf1, "SUNA ALARMA %d", var);
		ST7735R_DrawText(50, 50, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(20, 50, buf1, 0, 255, 255, 0, 0, 0);
		
		DS3231_getTime(&sec, &min, &h, &s, &d, &m, &y);
			
			
		sprintf(buf, "ORA: %d:%d:%d", h,min,sec);
		//
		ST7735R_DrawText(0, 130, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 130, buf, 0, 255, 255, 0, 0, 0);
		_delay_ms(100);
		
		speaker_morse(MORSE_LUNG);
      

		
	}
	PORTA &= ~(1 << PA6);
	alarm_set = 0;
}


int main(void) {
	uint8_t sec, min, h, m, d, y, s;
	SREG = 0;
	SREG |= (1<<7);
	
	StepperInit();
	SPI_init();
    ST7735R_Begin();
	ST7735R_FillRect(0, 0, ST7735R_WIDTH - 1, ST7735R_HEIGHT - 1, 0, 0, 0);
	
	DDRC |= (1 << PC4);
	PORTC |= (1 << PC4);
	
	twi_INIT();
	DS3231_setTime(0,53,21,1,21,5,2018);
	IO_init();
	int i = 0;
	while(1){
	setare_alarma();
	
	sprintf(buf1, "ALARMA SETATA");
	ST7735R_DrawText(50, 50, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(20, 50, buf1, 0, 255, 255, 0, 0, 0);
	
	sprintf(buf, "Ati setat %d:%d", ora_alarma, min_alarma);
	ST7735R_DrawText(50, 100, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
	
	DS3231_getTime(&sec, &min, &h, &s, &d, &m, &y);
			
			
	sprintf(buf, "ORA: %d:%d:%d", h,min,sec);
	//
	ST7735R_DrawText(0, 130, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(0, 130, buf, 0, 255, 255, 0, 0, 0);
	
		while(1){
			
			
			DS3231_getTime(&sec, &min, &h, &s, &d, &m, &y);
			
			
			sprintf(buf, "ORA: %d:%d:%d", h,min,sec);
			//
			ST7735R_DrawText(0, 130, spaces, 255, 255, 0, 0, 0, 0);
			ST7735R_DrawText(0, 130, buf, 0, 255, 255, 0, 0, 0);
			
			if (ora_alarma == h && min_alarma == min) {
				suna_alarma();
				break;
			}
			
			
			_delay_ms(100);
		}
	}


	return 0;
}
